package no.soliditet.wsclients.ws3.jaxrpc.client;

import no.soliditet.info.util.DmWSClientHelper;
import no.soliditet.info.util.TheStub;
import no.soliditet.wsclients.ws3.jaxrpc.generated.ArrayOfDmWSAttribute;
import no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSAttribute;

import javax.xml.rpc.ServiceException;
import java.net.MalformedURLException;
import java.net.URL;

public abstract class DecisionMakerWebServices3ImplSuper {

   protected static final String DEFAULT_HOST = "www.soliditetd.no";
   protected URL url;
   protected org.apache.axis.client.Stub stub;

   public DecisionMakerWebServices3ImplSuper(String hostName) throws MalformedURLException, ServiceException {
      if ((hostName == null) || (hostName.trim().length() == 0)) {
         hostName = DEFAULT_HOST;
      }

      String urlName;
      if (!hostName.startsWith("http")) {
         urlName = "https://" + hostName;
      }
      else {
         urlName = hostName;
      }

      url = new URL(urlName + getEndPointUrl());
      stub = getStubInstance();
      stub.setTimeout(60000 * 5);
      // don't need the proxy for these requests:
      //WSClientHelper.getInstance().resetProxy(stub);
      DmWSClientHelper.getInstance().setupProxyIfNeeded((TheStub)null, true, false);
   }

   protected no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSSingleResponse handleClientSideError(Exception e) {
      no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSError error = new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSError();
      if ((e instanceof NullPointerException) || ((e != null) && e.getMessage().equals("java.lang.NullPointerException"))) {
         error.setErrorMeasure("Error on Axis1 client side. Got NullPointerException.");
      }
      else {
         error.setErrorMeasure(e == null ? "Unknown" : e.getMessage());
      }
      return error;
   }

   protected abstract org.apache.axis.client.Stub getStubInstance() throws ServiceException;

   protected abstract String getEndPointUrl();

   /**
    * Finds the text message for the attribute named "action". If none found, null is returned
    *
    * @param element
    * @return the text string
    */
   static public String getActionMessage(no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSElement element) {
      return getAttributeValue(element, "action");
   }

   /**
    * Looks through all attributes for a specific named attribute key
    *
    * @param element
    * @param key
    * @return the text/value associated with the attribute. If none found, null is returned
    */
   static public String getAttributeValue(no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSElement element, String key) {
      if ((element == null) || (key == null)) return null;
      ArrayOfDmWSAttribute arrayOfattrs = element.getAttributes();
      if ((arrayOfattrs != null) && (arrayOfattrs.getItem() != null) && (arrayOfattrs.getItem().length > 0)) {
         DmWSAttribute[] attrs = arrayOfattrs.getItem();
         for (no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSAttribute attr : attrs) {
            if (attr != null) {
               if (attr.getName().equals(key)) {
                  // got it, return text
                  return attr.getText();
               }
            }
         }
      }
      return null;
   }

   public org.apache.axis.client.Stub getStub() {
      if (url.getHost().equals("localhost") || url.getHost().equals("127.0.0.1")) {
         DmWSClientHelper.getInstance().resetProxy(stub);
      }
      return stub;
   }

   public URL getUrl() {
      return url;
   }

   public static String getDefaultHost() {
      return DEFAULT_HOST;
   }
}
