package no.soliditet.wsclients.ws3.jaxrpc.client;

import no.soliditet.util.xml.XmlConstants;
import no.soliditet.util.xml.dom.XmlDOMDocument;
import no.soliditet.util.xml.dom.XmlDOMElement;
import no.soliditet.wsclients.ws3.jaxrpc.generated.*;
import org.xml.sax.SAXException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.rpc.ServiceException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.rmi.RemoteException;
import java.util.List;

class MyJAXRPCWS3Test {

	/**
	 * First argument (args[0]) assumed to be url (like "https://www.soliditetd.no")
	 *
	 * @param args
	 */
	@SuppressWarnings({"ForLoopReplaceableByForEach"})
	public static void main(String[] args) {
		DecisionMakerWebServices3Impl lindorffWS;
		try {
			//Constuct webservice object using default host name (www.soliditetd.no)
			//or take the name from input argument:
			String hostName = null;
			if ((args != null) && (args.length > 0) && (args[0].trim().length() > 0)) {
				hostName = args[0].trim();
			}

			//hostName = "http://localhost:7001";
			//hostName = "http://139.118.53.24:7001";

			lindorffWS = new DecisionMakerWebServices3Impl(hostName);

			DmWSApplicant applicant = getApplicantObject();

			// COMPANY SEARCH:
			applicant.setType("F");    // The applicant is a Company, not a person ("P")
			//applicant.setName("Soliditet Decision");	//search by name.....
			applicant.setSsn("983498051");          // ...or by org. no.
			//applicant.setNationality("no");       // norwegian is default

			// PERSON SEARCH:
			//applicant.setType("P");    // The applicant is a Person, not a company ("F")
			//applicant.setSsn("10106011430");

			//applicant.setFirstName("Eynar");
			//applicant.setLastName("Lindorff");

			// set username and password
			//String userName = "system";
			//String passWord = "system";
			String userName = "stest42";
			String passWord = "s42work";

			// Scoring on specific company policies (if any)
			String productName = "SPK Person";
			no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSSingleResponse srsp = null;//lindorffWS.score(userName, passWord, null, null, applicant, productName);
			DmWSRequest rqst = getRequestObject();
			rqst.setCustomerId("");
			rqst.setUser(userName);
			rqst.setPassWord(passWord);

			/*
			DmWSScoreRequest scoreRq = getScoreRequestObject();
			ArrayOfDmWSApplicant arrayOfApplicants = new ArrayOfDmWSApplicant();
			arrayOfApplicants.setItem(new DmWSApplicant[]{applicant});
			scoreRq.setApplicants(arrayOfApplicants);
			scoreRq.setProductName(productName);
			ArrayOfDmWSSingleRequest asr = new ArrayOfDmWSSingleRequest();
			asr.setItem(new DmWSSingleRequest[]{scoreRq});
			rqst.setRequests(asr);

			DmWSMemberValue[] members = new DmWSMemberValue[3];
			DmWSAppInfo appInfo = getAppInfo();
			DmWSMemberValue gjeldsgrad = getMemberValueObject();
			gjeldsgrad.setName("Gjeldsgrad");
			gjeldsgrad.setSet(true);
			gjeldsgrad.setVal("3");
			members[0] = gjeldsgrad;

			DmWSMemberValue purringer1 = new DmWSMemberValue();
			purringer1.setName("Purringer");
			purringer1.setSet(true);
			purringer1.setVal("7");
			members[1] = purringer1;

			DmWSMemberValue purringer2 = new DmWSMemberValue();
			purringer2.setName("AndreGangsPurringer");
			purringer2.setSet(true);
			purringer2.setVal("2");
			members[2] = purringer2;
			ArrayOfDmWSMemberValue ams = new ArrayOfDmWSMemberValue();
			ams.setItem(members);
			appInfo.setMemberValues(ams);

			applicant.setAppInfo(appInfo);
			*/

			//DmWSResponse rsp = lindorffWS.scoreX(rqst);
			//srsp = rsp.getResponses().getItem()[0];

			// Get raw information (including Decision Score) from provider:
			DmWSResponse rsp = lindorffWS.getInformation(userName, passWord, null, null, applicant, "alpha:hocrba:xml:server");

			DmWSSingleResponse[] srspsArray = rsp.getResponses().getItem();
			int applicantsWritten = 0;

			for (int i = 0; i < srspsArray.length; i++) {
				DmWSSingleResponse srspx = srspsArray[i];
				if (srspx != null) {
					//	if (applicantsWritten == 0) {
					//output info about the applicant (but only once)
					//		applicantsWritten = outputApplicantInfo(srsp);
					//	}
					handleOneresponse(srspx);
				}
			}
		}
		catch (MalformedURLException e) {
			e.printStackTrace();
		}
		catch (ServiceException e) {
			e.printStackTrace();
		}
		catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	private static DmWSScoreRequest getScoreRequestObject() {
		DmWSScoreRequest sr = new DmWSScoreRequest();
/*
		sr.setAddInfo(new DmWSElement[]{getAddInfoObject()});
		sr.setComment("");
		sr.setExtended(false);
		sr.setProductName("");
		sr.setRequestId("");
		sr.setScoreGroupName("");
*/
		return sr;
	}

	private static DmWSElement getAddInfoObject() {
		DmWSElement addInfo = new DmWSElement();
/*
		addInfo.setAttributes(new DmWSAttribute[]{getWSAttributeObject()});
		addInfo.setElements(new DmWSElement[]{null});
		addInfo.setName("");
		addInfo.setType("");
		addInfo.setVal("");
*/
		return addInfo;
	}

	private static DmWSAttribute getWSAttributeObject() {
		DmWSAttribute attr = new DmWSAttribute();
/*
		attr.setName("");
		attr.setText("");
*/
		return attr;
	}

	private static DmWSRequest getRequestObject() {
		DmWSRequest rq = new DmWSRequest();
/*
		rq.setCustomerId("");
		rq.setPassWord("");
		rq.setUser("");
		rq.setUserRef("");
*/
		return rq;
	}

	private static DmWSEiendomsInfo getPropertyObject() {
		DmWSEiendomsInfo property = new DmWSEiendomsInfo();
/*
		property.setAddress(getAddressObject());
		property.setAreal("");
		property.setBruksnr("");
		property.setFestenr("");
		property.setGardsnr("");
		property.setKommunenr("");
		property.setSeksjonsnr("");
*/
		return property;
	}

	private static DmWSApplicant getApplicantObject() {
		DmWSApplicant applicant = new DmWSApplicant();
/*
		applicant.setAddress(getAddressObject());
		applicant.setAddress2(getAddressObject());
		applicant.setAppInfo(getAppInfo());
		applicant.setEiendomsInfo(getPropertyObject());
		applicant.setEmail("");
		applicant.setExtClientNr("");
		applicant.setFirstName("");
		applicant.setLastName("");
		applicant.setName("");
		applicant.setNationality("");
		applicant.setSsn("");
		applicant.setType("");
*/
		return applicant;
	}

	private static DmWSAppInfo getAppInfo() {
		DmWSAppInfo appInfo = new DmWSAppInfo();
/*
		appInfo.setName("");
		appInfo.setMemberValues(new DmWSMemberValue[]{getMemberValueObject()});
*/
		return appInfo;
	}

	private static DmWSMemberValue getMemberValueObject() {
		DmWSMemberValue member = new DmWSMemberValue();
/*
		member.setName("");
		member.setSet(false);
		member.setVal("");
*/
		return member;
	}

	private static DmWSAddress getAddressObject() {
		DmWSAddress address = new DmWSAddress();
/*
		address.setCity("");
		address.setCountry("");
		address.setHouseLetter("");
		address.setHouseNo("");
		address.setHouseSubNo("");
		address.setStreet("");
		address.setZipcode("");
*/
		return address;
	}

	/**
	 * Outputs info about the error, scoring or information result
	 *
	 * @param rsp
	 */
	private static void handleOneresponse(no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSSingleResponse rsp) {
		if (rsp instanceof no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSError) {
			handleErrorResponse((no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSError)rsp);      //we got an error
		}
		else if (rsp instanceof no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSInformationResponse) {
			handleInformationResponse((no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSInformationResponse)rsp);
		}
		else if (rsp instanceof no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSScoreResponse) {
			handleScoreResponse((no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSScoreResponse)rsp);
		}
	}

	private static void handleScoreResponse(no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSScoreResponse srsp) {
		System.out.println("\n\nFrom ScoreResponse object:");
		//If this response only contains old obsolete norwegian scoremodels like 1 or 2, they are of no interest,
		//so we have to check for some we want first. These are models 3, 4, 5 or 6. 4, 5 and 6 never occurs at
		//the same time. model 3 (Payment Index) is delivered simultaneously if subscribed for
		no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSScoring scoring = null;
		ArrayOfDmWSScoring arrayOfscorings = srsp.getScorings();
		if ((arrayOfscorings != null) && (arrayOfscorings.getItem() != null) && (arrayOfscorings.getItem().length > 0)) {
			DmWSScoring[] scorings = arrayOfscorings.getItem();
			for (no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSScoring dmWSScoring : scorings) {
				if (dmWSScoring != null) {
					String mId = dmWSScoring.getZoneModelId();
					int modelNoL = Integer.parseInt(mId);
					if ((modelNoL == 3) || (modelNoL == 4) || (modelNoL == 5) || (modelNoL == 6)) {
						scoring = dmWSScoring;
						break;   //got it, so break;
					}
				}
			}
		}
		if (scoring == null) {
			//none of interest, ignore it
			return;
		}

		//get zone value:
		int izone = stringToInteger(scoring.getZone());

		//get the decision:
		String result = srsp.getResult();
		String decision = "not set";
		if (result != null) {
			decision = getDecision(result);
		}
		else {
			//if the result is from the raw data from provider (Soliditet Decision) the result is not set.
			//Soliditet Decision delivers the result only as a zone value
			//This means we will have to convert the zone into a decision.
			//We have an array of no.soliditet.wsclients.ws3.generated.DmWSZone objects. There is one object per zone, telling what decision that
			//zone results in. In other words, we must loop thru the array, find the correct zone object and take
			//the decision value from there.
			ArrayOfDmWSZone arrayOfzones = scoring.getZones();
			if ((arrayOfzones != null) && (arrayOfzones.getItem() != null) && (arrayOfzones.getItem().length > 0)) {
				DmWSZone[] zones = arrayOfzones.getItem();
				for (no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSZone zone : zones) {
					if (stringToInteger(zone.getZone()) == izone) {
						decision = getDecision(zone.getResult());
						break;  //we got it, no need to look for more
					}
				}
			}
		}
		System.out.println("The decision is \"" + decision + "\"");

		//Policyrules may affect the total decision.
		//If a client/applicant is denied, one may want to know why.
		//This is due to either a very low rating zone, or to one or more policy rule(s)
		//that occurred. The applicant may owe a lot of money (payment remarks) and the store (like Tele 2)
		//may not want such customers.

		//The score/rating zone (0 and 1 is deny, 2 is check, 3,4 and 5 is approved)
		//System.out.println("Rating zone is " + srsp.getZone());

		int modelNo = stringToInteger(scoring.getZoneModelId());
		String zoneText = getZoneText(modelNo, izone);
		System.out.println("Kredittsone: " + izone + ": " + zoneText);

		//The following policyrules occured:
		//int policiesFound = 0;
		ArrayOfDmWSPolicyElement arrayOfpes = scoring.getPolicyElements();

		if ((arrayOfpes != null) && (arrayOfpes.getItem() != null) && (arrayOfpes.getItem().length > 0)) {
			DmWSPolicyElement[] pes = arrayOfpes.getItem();
			//Ok, some policyelements occurred, loop thru:
			System.out.println("\n\nThe following policy rules occurred:");
			for (no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSPolicyElement pe : pes) {
				//print policyname and message
				String pename = pe.getName();
				System.out.print(pename + ": " + DecisionMakerWebServices3Impl.getActionMessage(pe));
				//in some cases the customer (like Tele2) wants even more details
				//A policyelement may have an array of no.soliditet.wsclients.ws3.generated.DmWSElement objects containing even more info:
				ArrayOfDmWSElement arrayOfelements = pe.getElements();
				if ((arrayOfelements != null) && (arrayOfelements.getItem() != null) && (arrayOfelements.getItem().length > 0)) {
					DmWSElement[] elements = arrayOfelements.getItem();
					for (no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSElement element : elements) {
						//policiesFound++;
						//The element has a name and a value,
						// e.g: "Income: 345000", "Paymentremarks: 4" etc
						//if only one sub element, don't bother displaying the name once again if the same as parent:
						String name = element.getName();
						if (pename.equalsIgnoreCase(name) && (elements.length == 1)) {
                     System.out.println(", " + element.getVal());
                  }
						else {
                     System.out.println(name + ": " + element.getVal());
                  }
					}
				}
			}
		}

		//Want to get hold of the totalscore elements? Only returned for actual score, not for raw data:
		//Actually same as for policyelements:
		ArrayOfDmWSTotalScoreElement arrayOftes = scoring.getTotalScoreElements();
		if ((arrayOftes != null) && (arrayOftes.getItem() != null) && (arrayOftes.getItem().length > 0)) {
			DmWSTotalScoreElement[] tes = arrayOftes.getItem();
			System.out.println("\n\nThe following total score elements are present:");
			for (no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSTotalScoreElement te : tes) {
				//print element name and message
				System.out.println("\n" + te.getName() + ": ");
				ArrayOfDmWSAttribute arrayOfattributes = te.getAttributes();
				if ((arrayOfattributes != null) && (arrayOfattributes.getItem() != null) && (arrayOfattributes.getItem().length > 0)) {
					DmWSAttribute[] attributes = arrayOfattributes.getItem();
					for (no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSAttribute attribute : attributes) {
						System.out.println("\nAttribute name: " + attribute.getName() + " value is \"" + attribute.getText() + "\"");
					}
				}
				//in some cases the customer (like Tele2) wants even more details
				//A total score element may have an array of no.soliditet.wsclients.ws3.generated.DmWSElement objects containing even more info:
				ArrayOfDmWSElement arrayOfelements = te.getElements();
				if ((arrayOfelements != null) && (arrayOfelements.getItem() != null) && (arrayOfelements.getItem().length > 0)) {
					DmWSElement[] elements = arrayOfelements.getItem();
					for (no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSElement element : elements) {
						//The element has a name and a value,
						System.out.println(element.getName() + ": " + element.getVal());
					}
				}
			}
		}
	}

	private static String getZoneText(int modelNo, int izone) {
		String zoneText;
		String modelText;
		if (modelNo == 3) { //Decision Payment Index
			//Payment Index er en scoringlsning som rangerer foretakene etter sannsynlighet for mislighold.
			modelText = "Decision Payment Index";
			switch (izone) {
				case 1:
					zoneText = "Rd sone";
					break;
				case 2:
					zoneText = "Gul sone";
					break;
				case 3:
					zoneText = "Grnn sone";
					break;
				default:
					zoneText = "Payment Index ikke beregnet";
			}
		}
		else if (modelNo == 5) { // Decision Score Company
			modelText = "Decision Score Company";
			switch (izone) {
				case 1:
					zoneText = "Kreditt kun mot sikkerhet";
					break;
				case 2:
					zoneText = "Kreditt mot sikkerhet anbefales";
					break;
				case 3:
					zoneText = "Kredittverdig";
					break;
				case 4:
					zoneText = "Hy kredittverdighet";
					break;
				case 5:
					zoneText = "Hyeste kredittverdighet";
					break;
				default:
					zoneText = "Foretaket er ikke ratet";
					break;
			}
		}
		else { //presumeably model 4 (actually ENK companies) or 6, i.e. Decision Score Person
			modelText = "Decision Score " + (modelNo == 6 ? "Person" : "Company");
			switch (izone) {
				case 1:
					zoneText = "Hy risiko";
					break;
				case 2:
					zoneText = "Moderat risiko";
					break;
				case 3:
					zoneText = "Lav risiko";
					break;
				case 4:
					zoneText = "Lav risiko";
					break;
				case 5:
					zoneText = "Lav risiko";
					break;
				default:
					zoneText = "Personen er ikke ratet";
					break;
			}
		}

		System.out.println("\n\nScore model: " + modelText);
		return zoneText;
	}

	private static void handleInformationResponse(no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSInformationResponse irsp) {
		System.out.println("\n\nFrom InformationResponse object:");
		String informationResult = irsp.getInformationResult();
		System.out.println("Raw Xml:\n" + informationResult);

		//It could be a scoring in there
		//We could extract some stuff from that using XPath.
		//In this example we've used Dom4J and Xerces

		try {
			XmlDOMDocument doc = new XmlDOMDocument(informationResult, XmlConstants.DEFAULT_ENCODING);
			String szone = doc.getXPathValue("/info/exti/alpha/cr/Rating3/CreditZone/@value");
			String smodelNo = doc.getXPathValue("/info/exti/alpha/cr/Rating3/Model/@value");

			String zoneText = getZoneText(stringToInteger(smodelNo), stringToInteger(szone));
			System.out.println("Kredittsone fra xml: " + szone + ": " + zoneText);

			//Any policycodes?
			List nodeList = doc.getXPathList("/info/exti/alpha/cr/Rating3/Comment/Comment");
			if ((nodeList != null) && (nodeList.size() > 0)) { //any?
				//avoid foreach loop on DOM4J, wn't work
				//noinspection ForLoopReplaceableByForEach
				for (int i = 0; i < nodeList.size(); i++) {
					XmlDOMElement element = XmlDOMElement.getAsElement(nodeList.get(i));
					if (element != null) {
						System.out.println("Policyname from xml: " + element.getAttributeValue("value"));
					}
				}
			}
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		catch (ParserConfigurationException e) {
			e.printStackTrace();
		}
		catch (SAXException e) {
			e.printStackTrace();
		}
	}

	private static void handleErrorResponse(no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSError error) {
		System.out.println("Error: " + error.getErrorCode() + ": " + error.getErrorMessage());
		//One may also want to get hold of the error measure
		System.out.println("What to do: " + error.getErrorMeasure());
	}

	private static String getDecision(String result) {
		String decision = "not set";
		if (result.equals("y")) {
         decision = "approved";
      }
		else if (result.equals("n")) {
         decision = "denied";
      }
		else if (result.equals("c")) {
         decision = "to be checked";
      }
		return decision;
	}

	private static int outputApplicantInfo(no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSSingleResponse srsp) {
		int didSome = 0;
		ArrayOfDmWSApplicant arrayOfapps = srsp.getApplicants();
		//Unless the score was done with a coapplicant, there is only one applicant, but lets
		//pass thru all:
		if ((arrayOfapps != null) && (arrayOfapps.getItem() != null) && (arrayOfapps.getItem().length > 0)) {
			DmWSApplicant[] apps = arrayOfapps.getItem();
			for (int i = 0; i < apps.length; i++) {
				no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSApplicant app = apps[i];
				if (app != null) {
					didSome++;
               //more than one applicant returned?
               if (apps.length > 1) {
                  System.out.println("Applicant no.: " + (i + 1));
               }
					if (app.getType().equals("P")) {
                  System.out.println("Name: " + app.getFirstName() + " " + app.getLastName());
               }
					else {
                  System.out.println("Name: " + app.getName());
               }

					no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSAddress address = app.getAddress();

					if (address != null) {
						System.out.println("Address: " + address.getStreet());
						//.....etc....
					}
					//.....etc....
				}
			}
		}
		return didSome;
	}

	private static int stringToInteger(String str) {
		try {
			return Integer.parseInt(str);
		}
		catch (Exception e) {
			return 0; //when unable to conver.
		}
	}
}
